package mi.hdm.recipes;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class Recipe implements RecipeComponent {
    private Map<RecipeComponent, Integer> ingredients;
    private String name;
    private String description;
    private List<String> preparation;
    private Set<Category> categories;
    private Integer preparationTimeMins;
    private LocalDateTime created;
    private NutritionTable nutritionTable;

    public Recipe(
            Map<RecipeComponent,Integer> ingredients,
            String name,
            String description,
            List<String> preparation,
            Set<Category> categories,
            Integer preparationTimeMins,
            NutritionTable nutritionTable) {
        this.ingredients = ingredients;
        this.name = name;
        this.description = description;
        this.preparation = preparation;
        this.categories = categories;
        this.preparationTimeMins = preparationTimeMins;
        this.nutritionTable = nutritionTable;

        created = LocalDateTime.now();
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public List<String> getPreparation() {
        return preparation;
    }

    public void setPreparation(List<String> preparation) {
        this.preparation = preparation;
    }

    public Set<Category> getCategories() {
        return categories;
    }

    public void setCategories(Set<Category> categories) {
        this.categories = categories;
    }

    public Integer getPreparationTimeMins() {
        return preparationTimeMins;
    }

    public void setPreparationTimeMins(int preparationTimeMins) {
        this.preparationTimeMins = preparationTimeMins;
    }

    public LocalDateTime getCreated() {
        return created;
    }

    public void setCreated(LocalDateTime created) {
        this.created = created;
    }

    public void setNutritionTable(NutritionTable nutritionTable) {
        this.nutritionTable = nutritionTable;
    }

    public NutritionTable getNutritionTable() {
        return nutritionTable;
    }
}
